;
;	Fjlkezel VT-DOS-ra
;
;
;

#include "defines.asm"

	.org 0100h			; a VT-DOS programok betltsi cme


pmain:	ld	sp,07FF0h		; sajt veremterlet kialaktsa U1 tetejn
;
	call	cmdline			; parancssor feldolgozsa
	ld	a,e			; grafikus md A reg.-be
	ld	(stmod),a
;
wstart:	ld	hl,08000h
	ld	(L0BF0h),hl		; pufferterlet kezdetnek belltsa (U2 RAM)
	ld	hl,04000h
	ld	(L0BF2h),hl		; pufferterlet mretnek belltsa
;
	call	ed_dosoff		; VT-DOS kurzor kikapcsolsa
	ld	de,fix_chmatrix		; karaktermtrix cmek belltsa
	call	ed_setfix
	ld	c,159			; C = az utols definlt karakter kdja
	ld	de,def_chmatrix		; DE= definilhat karaktermtrix cme
	call	ed_setdef
;
	call	fk_conf			; konfigurci beolvassa
;
	ld	a,(00080h)		; melegindts jelzse a parancssor hosszbjtja alapjn
	inc	a
	ld	a,(stmod)		; A reg.= grafikus md a parancssorbl vagy a konfig fjlbl
	jr	nz,cstart		; ugrs, ha hideg indts
	or	004h			; soft init jelzse
cstart:	call	fk_start		; fjlkezel meghvsa
	call	ed_doson		; VT-DOS kurzor bekapcsolsa
;
exit:	jp	0000h			; vissza a VT-DOS-ba





;
;	Egy karakter olvassa a parancssorbl, ha zr nullt olvas,
;	akkor kzvetlenl visszatr a parancssor-rtelmezt meghv rutinhoz
;	in:  HL - az aktulis karakterre mutat a parancssorban
;	out:  A - kiolvasott karakter
;	     CY - CY=1 -> TAB vagy szkz
;
get_char:
	ld	a,(hl)			; aktulis karakter kiolvassa
	inc	hl
	cp	020h			; szkz vizsglata
	scf
	ret	z
	cp	009h			; TAB vizsglata
	scf
	ret	z
	or	a			; CY=0
	ret	nz			; visszatrs, ha mg nincs vge a parancssornak
	pop	hl			; verem kitakartsa
	ret				; vissza a f rutinba


;
;	Parancssor rtelmezse
;	in: -
;	out: E - grafikus md
;
cmdline:
	ld	e,002h			; E = 2  -> alapesetben 2-szn grafikus md
	ld	hl,00081h
cmdln0:	call	get_char
	jr	nc,cmdln0		; ugrs, ha nem bevezet szkz vagy TAB
cmdln1:	call	get_char
	jr	c,cmdln1		; ugrs, ha mg mindig bevezet szkz vagy TAB
	cp	'-'
	jr	nz,cmdln0		; ugrs, ha nem opcijel
	call	get_char
	call	fk_nagy			; karakter nagybetv alaktsa
	cp	'G'
	jr	nz,cmdln2		; ugrs, ha nem a grafikus mdra vonatkoz opci
	ld	e,000h			; E = 0 -> 4-szn grafikus md
	call	get_char
	jr	c,cmdln1		; ugrs, ha szkz vagy TAB kveti az 'G'-t
	ld	e,002h			; egybknt mgsem 4-szn a md
	jr	cmdln0
;
cmdln2:	jp	cmdln0			; itt lehet tovbbi opcikat kirtkelni



;
;	Vltozterletek elhelyezse
;
edstart	.equ	11800


#define SDC_DATAMEM	11850
#define SDC_DATAEND	SDC_DATAMEM + (250 * 22)


;
; Kls modulokbl beillesztend programrszek
;
;
	#include "data_sdc.asm"
;
	#include "sdc_lib.asm"
;
	#include "sdc_func.asm"
;
	#include "sdc_util.asm"
;
	#include "sdc_exec.asm"
;
	#include "sdc_cfg.asm"
;
	#include "editor.asm"
;
fix_chmatrix:
;
	#include "fix_char.asm"
;
def_chmatrix:
;
	#include "def_char.asm"
;

freemem	.equ	$			; az els szabad memricm a programkd utn

datamem	.equ	edstart			; vltozk adatterletnek kezdete

L0BF0h	.equ	eddataend + 000h	; CLI puffer kezdcmt tartalmaz vltoz (2 bjt)
L0BF2h	.equ	eddataend + 002h	; CLI puffer mrete (2 bjt)
spcopy	.equ	eddataend + 004h	; veremmutat mentett rtke j program indtsakor (2 bjt)
diskpg	.equ	eddataend + 006h	; SD illeszt memrialapozsi rtke (1 bjt)
stmod	.equ	eddataend + 007h	; fjlkezel indulsi videmdja (1 bjt)


plugs	.equ	SDC_DATAEND		; plugin adattblzat kezdete


;
; Memriaelhelyezkedsek ellenrzse, tfeds elkerlsre
;

#if (datamem < freemem)
	.echo "\r\n*** Hiba: a valtozok memoriaterulete belelog a programkodba!!! ***\r\n"
	.echo "SDC_DATAMEM-et novelni kell!\r\n"
#endif

	.echo "\r\nA programkod utani elso szabad memoriacim: "
	.echo freemem
	.echo "\r\nValtozo terulet kezdocime: "
	.echo datamem
	.echo "\r\n\r\n"

.end

