;
;-----------------------------------------------------------------
;
;	Fjlkezel segdprogram (kiegszt rszek)
;
;-----------------------------------------------------------------
;



;
;-----------------------------------------------------
;	Vlts BASIC-be
;-----------------------------------------------------
;
fk_basic:
	ld	hl,bvaltas		; HL az megerstst kr szvegre mutat
;
	CALL_FKPMSG			; zenet kirsa az als sorba
;
	call	fk_kerd			; krds, s vrakozs a vlaszra
	ld	a,092h			; .CTRLC - megszaktottk a parancs vgrehajtst (CLI hibakd)
	ret	nz			; visszatrs, ha a mgsem-et vlasztottk
	ld	a,(diskpg)		; A reg.= diszk RAM memrialapozsi rtke
	bit	7,a			; 7. bit vizsglata
	ld	hl,0D020h		; HL= BOOT_DRV vltoz cme interfsz krtynl
	jr	nz,fk_bas0		; ugrs, ha interfsz krtya
	ld	hl,0E020h		; HL= BOOT_DRV vltoz cme cartridge-nl
fk_bas0:ld	de,0DFF2h - 0D020h	; DE= DOSCART s BOOT_DRV vltozk kztti cmklnbsg
	di
	out	(002h),a		; memrialapozs belltsa
	xor	a
	ld	(hl),a			; BOOT_DRV = 000h
	add	hl,de
	ld	(hl),a			; DOSCART vltoz = 000h -> BASIC-ben indul jra a rendszer
	ld	a,0B0h			; U0,U1,U2,U3 lapozs
	out	(002h),a		; memrialapozs belltsa
	ld	hl,fk_bas1		; HL= msoland kdrszlet kezdete
	ld	de,08000h		; DE= tkapcsol rutin kezdcme (nem lehet a 0. lapon!)
	ld	bc,baslen		; BC= msoland hossz
	ldir
	jp	08000h			; ugrs az tkapcsol rutinra


;
;	tmsolt kdrszlet
;
fk_bas1:ld	a,0A0h			; SYS,U1,U2,U3 lapozs
	out	(002h),a		; memrialapozs belltsa
	jp	0000h			; ugrs a rendszerindtsi cmre

baslen	.equ	$ - fk_bas1	




;
;-----------------------------------------------------
;	Szveges s hexa fjlnz
;-----------------------------------------------------
;

tb_txt	.text	" b\220jt\000"
tv_txt	.text	"T-Text H-Hexa ESC-kil\221p\221s\000"


;
;	Fjlnz f rutinja
;	in: -
;	out: CY - CY=1 -> knyvtr van kivlasztva, nem nyithat meg
;
fk_tview:
;
	CALL_FKPCPY			; aktulis tvonalstring tmsolsa az U0 RAM-ba 
;
	ld	a,(xaktbj)
;
	CALL_FKFADR			; aktulis bejegyzs cme HL-be
;
	push	hl			; kezdcm mentse
	ld	de,11
	add	hl,de
	ld	a,(hl)
	pop	hl			; cm vissza
	and	10h			; attribtum ellenrzse
	scf				; CY=1
	ret	nz			; visszatrs, ha nem fjl van kivlasztva
	ex	de,hl			; HL mentse
;
	CALL_FKPAL0			; teljesen fekete paletta belltsa
;
	ex	de,hl			; HL vissza
	ld	c,0			; GRAPHICS 2 belltsa, kperny trlse
	call	ed_vidmode
	ld	a,(L0BF2h + 1)		; A = CLI puffer mretnek fels bjtja
	and	0FEh			; puffermret lefel kerektse n*512 bjtra
	cp	004h
	ld	a,08Ch			; hibakd: .NORAM - nincs elg memria
	jp	c,fk_terr		; visszatrs, ha a CLI puffer kisebb 2 * 512 bjtnl
;
	CALL_FKFRST			; els keresse
;
	or	a			; volt hiba?
	jp	nz,fk_terr		; ha igen, vissza a hvhoz
	ld	de,FCB_0		; FCB_0 a tallt meghatrozott FCB
	ld	hl,FCB_1		; FCB_1 a keressi FCB
	ld	a,00Ch			; A = FISH funkci: fjl megnyitsa
;
	CALL_FKFISH			; FISH funkci hvsa
;
	or	a			; volt hiba?
	jp	nz,fk_terr		; ha igen, vissza a hvhoz
	ld	hl,FCB_0 + 8		; HL a tallt fjlnvre mutat
;
	CALL_FKNAME			; fjlnv kirsi formtum elksztse
;
	ld	bc,00200h		; X= 2  Y= aktulis sor
	ld	hl,fnamebuff		; fjlnv kirsa
	call	ut_prn0
	ld	de,strbuff
	ld	hl,FCB_0 + 01Ah		; HL a fjlmret MSB bjtjra mutat
;
	CALL_BIN2ASCII			; fjlmret a stringbufferbe
;
	ld	bc,01000h		; X= 16  Y= aktulis sor
	or	a			; CY= 0
	call	ut_prn4			; szveg kirsa a kpernyre
	ld	hl,tb_txt		; 'bjt'
	call	ut_prnt
	ld	bc,02700h		; X= 39  Y= aktulis sor
	ld	hl,tv_txt		; billentyfunkcik kirsa
	call	ut_prn0
	ld	a,001h			; a fejlcsor invertlsa
	ld	c,000h			; sor elejtl
	ld	de,0400Ah		; 64 karakter s 10 sor invertlsa
;
	CALL_FKLINV_PAR
;
	ld	hl,0000h		; kperny_mutat= 0 -> a fjl elejn kezdi a megjelentst
	ld	(scrptr),hl
	ld	(scrptr+2),hl
;
;
;	TEXT megjelents
;
	ld	a,62			; teljes md
	ld	(ln_dsply),a		; megjelenthet sorhossz belltsa
fk_tvw:	call	fk_txw0			; kezd kperny megjelentse kpernymutattl kezdve
fk_tvw0:ld	c,008h			; vrakozs egy gomb lenyomsra (konzol input echo nlkl)
	call	0005h			; VT-DOS hvsa
	cp	0FEh			; bal oldali joystick rtkeinek konvertlsa
	jr	nz,fk_tv1b		; ugrs, ha nem bal-fl
	ld	a,01Eh
fk_tv1b:cp	0FFh
	jr	nz,fk_tvw1		; ugrs, ha nem bal-le
	ld	a,01Fh
fk_tvw1:cp	'p'			; p - kvetkez oldal (Page Down)
	jr	nz,fk_tvw2
	call	fk_txsi			; kvetkez oldal cmnek szmtsa s fjlvg elrsnek ellenrzse
	ld	de,(dptrbuff)		; BC:DE= olvasand fjlcm az adatmutatbl
	ld	bc,(dptrbuff+2)
	call	nc,fk_txw		; kperny megjelentse, ha a kijelzend sor kezdete nem lg tl a fjl vgn
	jp	fk_tvw0
fk_tvw2:cp	'P'			; P - elz oldal (Page Up)
	jr	nz,fk_tvw4
	ld	b,23			; 23 sort prbl lptetni visszafele
fk_tvw3:push	bc
	call	fk_tsf			; fell kvetkez sor bemsolsa a stringbufferbe
	pop	bc
	or	a
	jr	z,fk_tv3b		; ugrs, ha 0 a bemsolt sor hossza
	ld	hl,(scrptr)		; kperny-mutat cskkentse az j kezdsor hosszval
	ld	d,000h
	ld	e,a
	sbc	hl,de			; CY=0 volt
	ld	(scrptr),hl
	ld	hl,(scrptr+2)
	ld	e,d
	sbc	hl,de
	ld	(scrptr+2),hl
	djnz	fk_tvw3			; ismtls, amg nem lpett vissza a szksges sorszmmal
fk_tv3b:call	fk_txw0			; kperny megjelentse kpernymutattl kezdve
	jp	fk_tvw0
fk_tvw4:call	fk_tngy			; kisbetk nagybetv konvertlsa (?)
	cp	01Fh			; JOY le
	jr	nz,fk_tvw5
	call	fk_txsi			; alul belp sor cmnek szmtsa s fjlvg elrsnek ellenrzse
	jp	c,fk_tvw0		; ugrs, ha a kijelzend sor kezdete tllg a fjl vgn
	call	fk_tvup			; kperny scrollozsa felfel
	ld	hl,(scrptr)		; kperny-mutat nvelse egy sorral
	ld	a,(linlenbuff)		; A reg.= az els sor hossza
	ld	e,a			; sorhossz DE-be
	ld	d,000h
	add	hl,de
	ld	(scrptr),hl
	ld	hl,(scrptr+2)
	ld	e,d
	adc	hl,de
	ld	(scrptr+2),hl
	ld	bc,1*256+tvlst_ln	; X=1  Y=utols sor
	call	ed_cpos			; kurzor-pozicionls
	ld	bc,22			; sorhossz-tmb elrelptetse 1 bjttal
	ld	de,linlenbuff		; DE= sorhossz-tmb eleje
	ld	hl,linlenbuff+1		; HL= sorhossz-tmb msodik elemnek cme
	ldir
	ex	de,hl			; HL a sorhossz-tmb 23. elemre mutat
	ld	de,(dptrbuff)		; BC:DE= olvasand fjlcm az adatmutatbl
	ld	bc,(dptrbuff+2)
	call	fk_wtex			; kvetkez sor kirsa
	jp	fk_tvw0
fk_tvw5:cp	01Eh			; JOY fel
	jr	nz,fk_tvw6
	call	fk_tsf			; fell kvetkez sor bemsolsa a stringbufferbe
	or	a
	jp	z,fk_tvw0		; ugrs, ha 0 a bemsolt sor hossza
	ld	bc,22			; sorhossz-tmb htralptetse 1 bjttal
	ld	de,linlenbuff+22	; DE= sorhossz-tmb vge
	ld	hl,linlenbuff+21	; HL= sorhossz-tmb utols eltti elemnek cme
	lddr
	ld	(de),a			; belp sor hossznak bersa a 0. elembe
	ld	hl,(scrptr)		; kperny-mutat cskkentse az j kezdsor hosszval
	ld	c,a
	sbc	hl,bc			; CY=0 volt
	ld	(scrptr),hl
	ld	hl,(scrptr+2)
	ld	c,b
	sbc	hl,bc
	ld	(scrptr+2),hl
	call	fk_tvdw			; kperny scrollozsa lefel
	ld	bc,1*256+tvfst_ln	; X=1  Y=els sor
	call	ed_cpos			; kurzor-pozicionls
	ld	bc,63			; BC= kirand sorhossz
	ld	de,strbuff		; DE= stringbuffer
	call	ed_bkout		; sor kirsa
	jp	fk_tvw0
fk_tvw6:cp	'W'			; W- sortrses md be/ki
	jr	nz,fk_tvw7
	ld	b,62			; teljes md
	ld	a,(ln_dsply)		; megjelenthet sorhossz ellenrzse
	cp	b
	jr	nz,fk_tv6b
	ld	b,0FFh			; sortrses md
fk_tv6b:ld	a,b
	ld	(ln_dsply),a		; megjelenthet sorhossz belltsa
	ld	de,(scrptr)		; BC:DE= olvasand fjlcm a kperny-mutatbl
	ld	bc,(scrptr+2)
	call	fk_txw			; kperny frisstse
	jp	fk_tvw0
fk_tvw7:cp	'H'			; H- tvlts HEXA mdba
	jr	nz,fk_tvw8
	call	fk_tvcl			; kperny trlse
	jp	fk_thw
fk_tvw8:cp	27			; ESC
	jp	nz,fk_tvw0
	ret
;
;
;	HEXA megjelents
;
fk_thw:	ld	de,(scrptr)		; BC:DE= olvasand fjlcm a kperny-mutatbl
	ld	bc,(scrptr+2)
	call	fk_hscr			; kezd kperny megjelentse
fk_thw0:ld	c,008h			; vrakozs egy gomb lenyomsra (konzol input echo nlkl)
	call	0005h			; VT-DOS hvsa
	cp	0FEh			; bal oldali joystick rtkeinek konvertlsa
	jr	nz,fk_th1b		; ugrs, ha nem bal-fl
	ld	a,01Eh
fk_th1b:cp	0FFh
	jr	nz,fk_thw1		; ugrs, ha nem bal-le
	ld	a,01Fh
fk_thw1:cp	'p'			; p - kvetkez oldal (Page Down)
	jr	nz,fk_thw2
	call	fk_hxsi			; kvetkez oldal cmnek szmtsa s fjlvg elrsnek ellenrzse
	ld	de,(dptrbuff)		; BC:DE= olvasand fjlcm az adatmutatbl
	ld	bc,(dptrbuff+2)
	call	nc,fk_hscr		; kperny megjelentse, ha a kijelzend sor kezdete nem lg tl a fjl vgn
	jp	fk_thw0
fk_thw2:cp	'P'			; P - elz oldal (Page Up)
	jr	nz,fk_thw4
	ld	de,(scrptr)		; BC:DE= a kperny tetejn lv adat kezdcme
	ld	bc,(scrptr+2)
	ld	hl,-(tvfullscr)		; az elz kperny cmnek kiszmtsa
	add	hl,de
	ex	de,hl
	ld	hl,0FFFFh
	adc	hl,bc
	ld	c,l			; BC:DE= a kijelzend sor kezdcme
	ld	b,h
	jr	c,fk_thw3		; ugrs, ha a kijelzend kperny kezdete nem a 0. cm elttre esne
	ld	bc,0000h		; BC:DE= 0 -> a fjl elejn kezdi a megjelentst
	ld	de,0000h
fk_thw3:call	fk_hscr			; kperny megjelentse
	jp	fk_thw0
fk_thw4:call	fk_tngy			; kisbetk nagybetv konvertlsa (?)
	cp	01Fh			; JOY le
	jr	nz,fk_thw5
	call	fk_hxsi			; alul belp sor cmnek szmtsa s fjlvg elrsnek ellenrzse
	jp	c,fk_thw0		; ugrs, ha a kijelzend sor kezdete tllg a fjl vgn
	call	fk_tvup			; kperny scrollozsa felfel
	ld	hl,(scrptr)		; kperny-mutat nvelse egy sorral
	ld	de,0008h
	add	hl,de
	ld	(scrptr),hl
	ld	hl,(scrptr+2)
	ld	e,000h
	adc	hl,de
	ld	(scrptr+2),hl
	ld	bc,1*256+tvlst_ln	; X=1  Y=utols sor
	call	ed_cpos			; kurzor-pozicionls
	call	fk_hvw			; kvetkez sor kirsa
	jp	fk_thw0
fk_thw5:cp	01Eh			; JOY fel
	jr	nz,fk_thw6
	ld	de,(scrptr)		; BC:DE= a kperny tetejn lv adat kezdcme
	ld	bc,(scrptr+2)
	ld	hl,-8			; a fell kvetkez sor cmnek kiszmtsa
	add	hl,de
	ex	de,hl
	ld	hl,0FFFFh
	adc	hl,bc
	ld	c,l			; BC:DE= a kijelzend sor kezdcme
	ld	b,h
	ld	(dptrbuff),de		; cm mentse az adatmutatba
	ld	(dptrbuff+2),bc
	jp	nc,fk_thw0		; ugrs, ha a kijelzend sor kezdete a 0. cm elttre esne
	call	fk_tvdw			; kperny scrollozsa lefel
	ld	hl,(dptrbuff)		; kperny-mutat frisstse az j kezdsor cmvel
	ld	(scrptr),hl
	ld	hl,(dptrbuff+2)
	ld	(scrptr+2),hl
	ld	bc,1*256+tvfst_ln	; X=1  Y=els sor
	call	ed_cpos			; kurzor-pozicionls
	call	fk_hvw			; kvetkez sor kirsa
	jp	fk_thw0
fk_thw6:cp	'T'			; T- tvlts TEXT mdba
	jr	nz,fk_thw7
	call	fk_tsf			; fell kvetkez TEXT sor bemsolsa a stringbufferbe
	ld	hl,(scrptr)		; kperny-mutat cskkentse a tallt sor hosszval
	ld	b,000h
	ld	c,a
	or	a
	sbc	hl,bc
	ld	(scrptr),hl
	ld	hl,(scrptr+2)
	ld	c,b
	sbc	hl,bc
	ld	(scrptr+2),hl
	call	fk_tvcl			; kperny trlse
	jp	fk_tvw			; ugrs a TEXT mdra
fk_thw7:cp	27			; ESC
	jp	nz,fk_thw0
	ret


;
;	Adatok olvassa fjlbl a CLI pufferbe
;	in:  BC - tviteli hossz (max.512 bjt) 
;	out: BC - beolvasott hossz
;
fk_tvrd:ld	de,FCB_0		; FCB_0 a megnyitott FCB
	ld	ix,(L0BF0h)		; IX= CLI puffer kezdcme
	ld	a,00Fh			; A = FISH funkci: olvass fjlbl
;
	CALL_FKFISH			; FISH funkci hvsa
;
	or	a			; volt hiba?
	jr	z,fk_tvr0		; ugrs, ha nem
	cp	0ECh
	jr	nz,fk_terr		; ugrs, ha nem .EOF hiba
fk_tvr0:ld	(dbufflen),bc		; CLI pufferben lv bjtszm mentse
	ret


fk_terr:
;
	CALL_FKERROR			; hiba kirsa
;
	ld	bc,0000h		; fjl-olvassnl a beolvasott bjtok szma=0
	or	a			; CY=0
	ret

;
;	HEXA kpernyn alul kvetkez sor fjlcmnek kiszmtsa,
;	majd fjlvg tllpsnek vizsglata (sor cme a 'dptrbuff' vltozba kerl)
;	in: -
;	out: DE - htralv bjtok a fjl vgig (als sz)
;	     HL - htralv bjtok a fjl vgig (fels sz)
;	     CY - CY=1 mr tlhaladta a fjl vgt
;
fk_hxsi:ld	bc,0000h		; BC:DE= egy teljes kpernyn megjelenthet bjtok szma
	ld	de,tvfullscr
	jp	fk_txs2			; folytats a kperny-mutat nvelsvel, majd fjlvg ellenrzs

;
;	TEXT kpernyn alul kvetkez sor fjlcmnek kiszmtsa,
;	majd fjlvg tllpsnek vizsglata (sor cme a 'dptrbuff' vltozba kerl)
;	in: -
;	out: DE - htralv bjtok a fjl vgig (als sz)
;	     HL - htralv bjtok a fjl vgig (fels sz)
;	     CY - CY=1 mr tlhaladta a fjl vgt
;
fk_txsi:xor	a
	ld	b,23			; 23 sor hosszt kell sszegezni
	ld	c,a			; C = 0
	ld	d,a			; D-ben s A reg.-ben lesz a 16-bites sszeg
	ld	hl,linlenbuff		; HL= sorhossz-tmb mutat
fk_txs0:add	a,(hl)
	inc	hl
	jr	nc,fk_txs1		; ugrs, ha nincs tvitel az als 8 bitrl
	inc	d
fk_txs1:djnz	fk_txs0			; ismtls mind a 23 sorra
	ld	e,a			; DE-ben a teljes 16-bites eredmny
fk_txs2:ld	hl,(scrptr)		; a legalul kvetkez sor cmnek kiszmtsa
	add	hl,de
	ex	de,hl
	ld	hl,(scrptr+2)
	adc	hl,bc
	ld	c,l			; BC:DE= a kijelzend sor kezdcme
	ld	b,h
	ld	(dptrbuff),de		; cm mentse az adatmutatba
	ld	(dptrbuff+2),hl		; folytats a fjlvg ellenrzssel

;
;	Fjlvg ellenrzse
;	in:  BC - ellenrzend cm fels szava
;	     DE - ellenrzend cm als szava
;	out: DE - htralv bjtok a fjl vgig (als sz)
;	     HL - htralv bjtok a fjl vgig (fels sz)
;	     CY - CY=1 mr tlhaladta a fjl vgt
;
fk_ceof:ld	hl,(FCB_0 + 017h)	; HL-be a fjlmret als szava
	or	a
	sbc	hl,de
	ex	de,hl			; DE= klnbsg als szava
	ld	hl,(FCB_0 + 019h)	; HL-be a fjlmret fels szava
	sbc	hl,bc
	ret	c			; visszatrs, ha egyrtelmen tllpte a fjl vgt
	ld	a,h
	or	l
	or	d
	or	e
	ret	nz
	scf				; ha az eredmny 0, akkor is CY=1
	ret

;
;	TEXT kpernyn fell kvetkez sor bemsolsa a stringbufferbe
;	in: -
;	out:  A - a bufferbe msolt formzott sor tnyleges hossza
;
fk_tsf:	ld	de,(scrptr)		; BC:DE= a kperny tetejn lv adat kezdcme
	ld	bc,(scrptr+2)
	call	fk_tbk			; elz TEXT sor kezdetnek keresse
	ld	a,(ln_dsply)		; megjelenthet sorhossz vizsglata
	cp	62
	ld	a,e
	jr	z,fk_tsf0		; ugrs, ha nem sortrses zemmd van
	cp	tv_tmaxlen
	jr	nz,fk_tsf0		; ugrs, ha tallt sorvgjelet
	ld	a,63			; egybknt teljes sor megjelentse
	ld	de,tv_tmaxlen-63
	add	hl,de
fk_tsf0:ld	c,a			; C = feldolgozhat hossz
	push	bc			; sorhossz a verembe
	push	hl			; sor kezdcme a verembe
	call	fk_tex			; TEXT sor a stringbufferbe
	pop	hl
	pop	bc
	cp	c
	ret	z			; visszatrs, ha a teljes sort feldolgozta (pl. ha nincs sortrs)
	ld	d,000h			; DE= feldolgozott karakterek szma
	ld	e,a
	add	hl,de			; sor kezdcmnek thelyezse a sortrshez
	ld	a,c			; feldolgozhat hossz cskkentse
	sub	e
	jr	fk_tsf0

;
;	Egy TEXT sor kezdetnek keresse visszirnyban
;	in:  BC - kiindulsi kezdcm a fjlban, fels sz
;	     DE - kiindulsi kezdcm a fjlban, als sz
;	out:  E - sor hossza
;	     HL - sor kezdetre mutat a CLI pufferben
;
fk_tbk:	ld	hl,tv_tmaxlen		; a max. sorhossz 252 karakter
	ex	de,hl			; hossz DE-be
	or	a
	sbc	hl,de			; kezdcm cskkentse az olvasand hosszal
	jr	nc,fk_tbk1		; ugrs, ha nincs klcsnzs a fels szrl
	ld	a,b
	or	c
	jr	nz,fk_tbk0		; ugrs, ha BC nem 0000h
	add	hl,de			; HL visszalltsa
	ex	de,hl			; az olvasand hossz az aktulis fjlpozci
	ld	hl,0000h		; a fjl kezdettl fog olvasni
	inc	bc			; BC= 0001h
fk_tbk0:dec	bc
fk_tbk1:ld	(FCB_0 + 028h),hl	; mdostott adatmutat bemsolsa az FCB fjlmutatjba
	ld	(FCB_0 + 02Ah),bc
	ld	b,d			; BC= tviteli hossz
	ld	c,e
	call	fk_tvrd			; adatok olvassa
	ld	e,c			; olvasott hossz E-be is
	ld	hl,(L0BF0h)		; HL= CLI puffer kezdcme
	ld	a,b			; olvasott hossz vizsglata
	or	c
	ret	z			; visszatrs, ha nem olvasott egy bjtot sem
	add	hl,bc
	dec	hl			; HL az utols adatbjtra mutat
	dec	c
	ret	z			; visszatrs, ha csak egy bjtot olvasott (mindegy mi az)
	ld	a,(hl)
	dec	hl
	cp	00Ah			; '\n' - UNIX vagy DOS formtumnl
	jr	nz,fk_tbk2		; ugrs, ha nem '\n'
	ld	a,(hl)
	cp	00Dh			; '\r' - csak DOS-os text formtumnl
	jr	z,fk_tbk3		; ugrs, ha megegyezik
	jr	fk_tbk4
;
fk_tbk2:cp	00Dh			; '\r' - csak DOS-os text formtumnl
	jr	nz,fk_tbk4		; ugrs, ha az elz sor nem '\r'-re vgzdtt
fk_tbk3:dec	hl			; a kvetkez karakter tlpse
	dec	c
	ret	z			; visszatrs, ha nincs tbb adat
fk_tbk4:ld	a,e
	sub	c
	ld	d,a			; D= a sor vgn eddig tvizsglt bjtok szma
	ld	a,00Ah			; '\n' - UNIX vagy DOS formtumnl
	cpdr				; j-sor karakter keresse visszirnyban
	inc	hl	
	ret	nz			; visszatrs, ha nem tallt '\n' karaktert
	inc	hl			; HL a tallt '\n' karakter utni bjtra mutat
	ld	a,e
	sub	c			; A reg. = sszes tvizsglt bjtok szma
	dec	a			; a tallt '\n' karakter levonsa a sor hosszbl
	ld	e,a			; sorhossz E-be
	sub	d			; a sor vgn vizsglt karakterek levonsa
	ret	z			; visszatrs, ha a CPDR biztosan csak egy bjtot vizsglt (s az '\n' volt)
	ld	a,(hl)			; utols eltti vizsglt bjt A reg.-be
	cp	00Dh			; '\r' - csak DOS-os text formtumnl
	ret	nz			; visszatrs, ha nem "\n\r" sorvgzds volt
	inc	hl			; egybknt HL a kvetkez karakterre mutat
	dec	e			; sorhossz cskkentse
	ret

;
;	Egy teljes TEXT kperny kirsa
;	in:  BC - kirand adatok kezdcme a fjlban, fels sz
;	     DE - kirand adatok kezdcme a fjlban, als sz
;	out: -
;
fk_txw:	ld	(scrptr),de		; kperny-mutat belltsa
	ld	(scrptr+2),bc
fk_txw0:ld	bc,0101h		; X= 1  Y= 1 (a soremels hatsra a 2. sornl fog kezdeni)
	call	ed_cpos			; kurzor-pozicionls
	ld	de,(scrptr)		; kperny-mutat vissza BC:DE-be
	ld	bc,(scrptr+2)
	ld	hl,linlenbuff		; HL= sorhossz-tmb mutat
fk_txw1:push	hl
	push	bc			; adatmutat mentse
	push	de
	call	ut_lnf			; soremels
	pop	de
	pop	bc
	push	bc
	push	de
	call	fk_wtex			; egy sor kirsa
	pop	de			; adatmutat vissza
	pop	bc
	ld	h,000h			; HL= a fjlbl feldolgozott hossz
	add	hl,de			; adatmutat nvelse
	ex	de,hl
	jr	nc,fk_txw2
	inc	bc
fk_txw2:pop	hl			; HL= sorhossz-tmb mutat
	inc	hl
	ld	a,(linlenbuff + 23) & 0FFh
	cp	l			; cm als bjt vizsglata
	jr	nz,fk_txw1		; ismtls, amg nem rta tele mind a 23 sort
	ld	a,(linlenbuff + 23) >> 8
	cp	h
	jr	nz,fk_txw1		; ismtls, amg nem rta tele mind a 23 sort
	ret

;
;	Egy TEXT sor kirsa elre irny keresssel
;	in:  BC - kirand adatok kezdcme a fjlban, fels sz
;	     DE - kirand adatok kezdcme a fjlban, als sz
;	     HL - sorhossz-tmb mutat
;	out:  L - kirt sor tnyleges hossza
;
fk_wtex:push	hl			; sorhossz-tmb mutat mentse
	ld	(FCB_0 + 028h),de	; adatmutat tmsolsa az FCB fjlmutatjba
	ld	(FCB_0 + 02Ah),bc
	ld	bc,65			; BC= tviteli hossz (65 bjt)
	ld	a,(ln_dsply)		; megjelenthet sorhossz vizsglata
	cp	62
	jr	nz,fk_tex0		; ugrs, ha sortrses zemmd van
	ld	bc,tv_tmaxlen		; egybknt a max. sorhossz 252 karakter
fk_tex0:call	fk_tvrd			; adatok olvassa
	ld	hl,(L0BF0h)		; HL= CLI puffer kezdcme
	call	fk_tex			; TEXT sor a stringbufferbe
	pop	hl			; HL= sorhossz-tmb mutat
	ld	(hl),a			; tnyleges sorhossz mentse a tmbbe
	ld	l,a			; L= tnyleges sorhossz visszatrsi rtknek
	ld	bc,63			; BC= kirand sorhossz
	ld	de,strbuff		; DE= stringbuffer
	call	ed_bkout		; szveg kirsa
	ret

;
;	Egy TEXT sor tmsolsa a stringbufferbe
;	in:   C - feldolgozhat bjtok szma
;	     HL - a feldolgozand adatok kezdetre mutat (a CLI pufferben)
;	out:  A - a bufferbe msolt formzott sor tnyleges hossza
;
fk_tex:	push	hl			; adatok kezdetnek mentse
	ld	de,strbuff		; DE= kirshoz elksztett szveg eleje
	ld	b,c			; olvasott hossz B-be
	ld	a,c			; s A reg.-be is
	ld	c,000h			; C= oszlop-pozci
	or	a
	jr	z,fk_tex4		; ugrs, ha 0 bjtot olvasott
fk_tex1:ld	a,(hl)			; beolvasott karakterek vizsglata
	inc	hl
	call	fk_cclf			; sorvg ellenrzse
	jr	c,fk_tex4		; ugrs, ha sorvg
	call	fk_cchr			; karakter konvertlsa s trolsa
	ld	a,(ln_dsply)		; megjelenthet sorhossz vizsglata (pl. ha nincs sortrs)
	cp	c
	jr	nc,fk_tex2		; ugrs, ha mg nem haladta meg a megjelenthet hosszat
	ld	c,63			; pozcik fixlsa
	ld	de,strbuff+63
	jr	fk_tex3
fk_tex2:ld	a,62			; sortrses mdban a sorhossz ellenrzse
	cp	c
	jr	c,fk_tex6		; ugrs, ha az oszlop-pozci > 62
fk_tex3:djnz	fk_tex1			; ismtls az sszes beolvasott karakterig
fk_tex4:ld	a,62			; sorvgi res karakterek kiszmtsa
	sub	c
	ld	b,a			; B= res karakterek szma a sor vgn
	jr	c,fk_tex7		; ugrs, ha nincs res karakter
	inc	b			; B>0
	ld	a,020h
fk_tex5:ld	(de),a			; kitlts SPACE-el
	inc	de
	djnz	fk_tex5
	jr	fk_tex7
;
fk_tex6:pop	de			; DE= feldolgozott adatok kezdcme
	push	de
	or	a
	sbc	hl,de
	ld	a,l			; A reg.= tnyleges sorhossz
	add	hl,de
	cp	63
	jr	c,fk_tex7		; ugrs, ha 63-nl kevesebb karaktert dolgozott fel
	dec	b
	jr	z,fk_tex7		; ugrs, ha ez volt az utols beolvasott karakter (pl. fjl-vge)
	ld	a,(hl)			; A reg.= 64. karakter
	inc	hl
	call	fk_cclf			; sorvg ellenrzse
	jr	c,fk_tex7		; ugrs, ha tallt sorvget
	dec	hl			; egybknt HL visszalltsa
fk_tex7:pop	de			; DE= feldolgozott adatok kezdcme
	or	a
	sbc	hl,de
	ld	a,l			; A reg.= tnyleges sorhossz
	ret


;
;	Sorvg ellenrzse
;	in:   A - aktulis feldolgozand karakter
;	      B - a CLI pufferben htralv karakterek szma
;	     HL - a kvetket karakter cme a CLI pufferben
;	out:  A - aktulis feldolgozand karakter (frisstve, ha soremelst tallt)
;	      B - a CLI pufferben htralv karakterek szma (frisstve, ha soremelst tallt)
;	      C - megrzdik
;	     DE - megrzdik
;	     HL - a kvetket karakter cme a pufferben (frisstve, ha soremelst tallt)
;	     CY - CY=1 - soremels karaktereket tallt
;
fk_cclf:cp	00Ah			; '\n' - UNIX vagy DOS formtumnl
	jr	nz,fk_ccl2
	dec	b
	jr	z,fk_ccl1		; ugrs, ha nincs tbb feldolgozhat karakter
	ld	a,(hl)			; kvetkez karakter vizsglata
	cp	00Dh			; '\r' - csak DOS-os text formtumnl
	jr	nz,fk_ccl1
fk_ccl0:inc	hl
fk_ccl1:scf				; sorvg jelzse
	ret
;
fk_ccl2:cp	00Dh			; '\r' - csak DOS-os text formtumnl
	jr	nz,fk_ccl3
	ld	a,001h			; ilyenkor A reg. rtke mr kzmbs (legyen < 32), mert helyettestve lesz
	cp	b
	ret	z			; visszatrs, ha mr nincs tbb karakter a pufferben, CY= 0
	ld	a,(hl)			; kvetkez karakter vizsglata
	cp	00Ah			; '\n'
	jr	z,fk_ccl0		; ugrs, ha sor vge
fk_ccl3:or	a			; CY= 0
	ret


;
;	Karakterek konvertlsa s trolsa a stringbufferbe
;	in:   A - aktulis feldolgozand karakter
;	      C - oszlopcm
;	     DE - stringbuffer aktulis pozcija
;	     HL - a kvetket karakter cme a CLI pufferben
;	out:  B - megrzdik
;	      C - oszlopcm
;	     DE - oszlopcmmel egytt vltozik
;	     HL - a kvetket karakter cme a pufferben
;
fk_cchr:cp	009h			; TAB
	jr	nz,fk_cch1
	push	hl
	ld	a,008h			; oszlop-pozci felkerektse a TAB mrettel (8)
	add	a,c
	and	0F8h			; als 3 bit maszkolsa
	ld	l,c			; rgi oszlopcm L-be
	ld	c,a			; oszlopcm frisstse
	sub	l
	ld	l,a			; L= helyettest karakterek szma (0< L <=8)
	ld	a,020h
fk_cch0:ld	(de),a
	inc	de
	dec	l
	jr	nz,fk_cch0
	pop	hl
	or	a			; CY= 0
	ret
;
fk_cch1:push	bc
	cp	0C1h
	jr	nc,fk_cch2		; ugrs, ha kezetes karakter lehet
	cp	020h
	jr	nc,fk_cch5		; ugrs, ha 32-nl nem kisebb a bjt rtke
	ld	a,020h			; nem megjelenthet karakter helyettestse SPACE-el
	jr	fk_cch5
;
fk_cch2:push	hl			; ISO 8859-2 es Win 1250-es kdols kezetes karakterek konvertlsa
	ld	bc,0009h		; 9 kezetes bet ellenrzse
	ld	hl,smalett		; kisbetk kdjai
	cp	0E1h
	jr	nc,fk_cch3		; ugrs, ha kisbet lehet
	ld	hl,caplett		; nagybetk kdjai
fk_cch3:cpir
	pop	hl
	ld	a,020h			; A reg.= SPACE
	jr	nz,fk_cch5		; ugrs, ha nem kezetes bet
	ld	a,098h			; A reg.= '' kdja + 8
	jr	nc,fk_cch4		; ugrs, ha kisbet
	ld	a,088h			; A reg.= '' kdja + 8
fk_cch4:sub	c
fk_cch5:pop	bc
	ld	(de),a			; karakter kirsa a stringbufferbe
	inc	de
	inc	c			; oszlopcm nvelse
	or	a			; CY= 0
	ret

;
;	kezetes nagy- s kisbetk ISO 8859-2 szerinti kdjai
;
caplett	.db	0C1h,0C9h,0CDh,0D3h,0D6h,0D5h,0DAh,0DCh,0DBh
smalett	.db	0E1h,0E9h,0EDh,0F3h,0F6h,0F5h,0FAh,0FCh,0FBh
;


;
;	Egy teljes HEXA kperny kirsa
;	in:  BC - kirand adatok kezdcme a fjlban, fels sz
;	     DE - kirand adatok kezdcme a fjlban, als sz
;	out: -
;
fk_hscr:ld	(scrptr),de		; kperny-mutat belltsa
	ld	(scrptr+2),bc
	push	bc
	ex	de,hl
	ld	bc,0101h		; X= 1  Y= 1 (a soremels hatsra a 2. sornl fog kezdeni)
	call	ed_cpos			; kurzor-pozicionls
	ex	de,hl			; HL:DE= kezdcm
	pop	hl
	ld	b,tv_nlines		; B= sorok szma
	ld	a,008h			; A= egy sor hossza (ha elfogynnak az adatok, akkor kinullzdik)
fk_hsc0:ld	(dptrbuff),de
	ld	(dptrbuff+2),hl
	ld	l,a			; kirand sorhossz mentse L-be
	push	bc
	call	ut_lnf			; soremels
	ld	b,000h			; sorhossz BC-be
	ld	c,l
	call	fk_hvw0			; egy sor kirsa
	ld	hl,(dptrbuff)		; adatmutat nvelse egy sorral
	ld	de,0008h
	ld	b,d
	ld	c,d
	add	hl,de
	ex	de,hl
	ld	hl,(dptrbuff+2)
	adc	hl,bc
	pop	bc
	djnz	fk_hsc0			; ismtls az sszes sor kirsig
	ret

;
;	Egy HEXA sor kirsa a kpernyre
;	in:  BC - kirand hossz (csak fk_hvw0-nl belpve)
;	out:  A - megjelentett bjtok szma
;
fk_hvw:	ld	bc,0008h		; BC= tviteli hossz (8 bjt)
fk_hvw0:ld	hl,(dptrbuff)		; adatmutat tmsolsa az FCB fjlmutatjba
	ld	(FCB_0 + 028h),hl
	ld	hl,(dptrbuff+2)
	ld	(FCB_0 + 02Ah),hl
	ld	a,b
	or	c
	call	nz,fk_tvrd		; adatok olvassa, ha nem 0 a hossz
	ld	hl,(L0BF0h)		; HL= CLI puffer kezdcme
	push	bc
	call	fk_hex			; sor kirsa
	pop	bc
	ld	a,c
	ret

;
;	Egy HEXA sor elksztse a stringbufferbe s kirsa
;	in:   C - kirand memriarekeszek szma (<=8)
;	     HL - kirand memriaterlet kezdcme
;	out: -
;
fk_hex:	ld	a,c
	ld	c,tv_linlen		; C = egy sor hossza
	ld	de,strbuff		; DE= stringbuffer cme
	or	a
	jr	z,fk_hex4		; ugrs, ha 0 hosszsgot kell kirni
	ld	b,a			; B= kirand rekeszek szma
	ld	a,008h
	sub	b
	ld	c,a			; C = a ki nem rt rekeszek szma, ha 8-nl kevesebbet kell rni
	push	bc
	push	hl
	ld	hl,dptrbuff + 3		; HL a sor fjlon belli 32 bites cmnek MSB bjtjra mutat
	ld	b,004h			; 4 bjt lesz
fk_hex0:ld	a,(hl)
	dec	hl
	push	hl
	call	fk_hcon			; cm kirsa
	pop	hl
	djnz	fk_hex0
	ld	a,020h			; elvlaszt SPACE-k
	ld	(de),a
	inc	de
	ld	(de),a
	inc	de
	pop	hl			; HL= az adatokat tartalmaz buffer-kezdcm
	pop	bc			; B = kirand memriarekeszek szma
	push	bc			; C = a ki nem rt rekeszek szma, ha 8-nl kevesebbet kell rni
	push	hl
fk_hex1:ld	a,(hl)
	inc	hl
	push	hl
	call	fk_hcon			; cm kirsa
	pop	hl
	ld	a,020h			; elvlaszt SPACE
	ld	(de),a
	inc	de
	djnz	fk_hex1
	ld	a,c			; A reg. = a ki nem rt rekeszek szma
	add	a,c
	add	a,c
	ld	c,a			; C= C * 3 (minden kirshoz 3 karakter tartozik)
	inc	c			; plusz egy kitlt SPACE
	ld	l,e
	ld	h,d
	dec	hl
	ldir				; kitlt SPACE-k elhelyezse
	pop	hl			; HL= az adatokat tartalmaz buffer-kezdcm
	pop	bc			; B = kirand memriarekeszek szma
	push	bc
fk_hex2:ld	a,(hl)
	inc	hl
	cp	020h
	jr	nc,fk_hex3		; ugrs, ha 32-nl nem kisebb a bjt rtke
	ld	a,'.'			; nem megjelenthet karakter helyettestse
fk_hex3:call	fk_cch1			; kezetes karakterek konvertlsa, majd karakter trolsa
	djnz	fk_hex2
	pop	bc			; C = a ki nem rt rekeszek szma
fk_hex4:ld	a,020h			; SPACE-k kirsa az res helyekre
	inc	c
fk_hex5:dec	c
	jr	z,fk_hex6		; ugrs, ha mr mindet kirta
	ld	(de),a
	inc	de
	jr	fk_hex5
fk_hex6:ld	bc,tv_linlen		; BC= az egy sorba rt karakterek szma
	ld	de,strbuff		; DE= szveg eleje
	call	ed_bkout		; szveg kirsa
	ret

;
;	8-bites HEXA szm kirsa stringbufferbe
;	in:   A - kirand bjt
;	     DE - hova
;	out: BC - megrzdik
;	     DE - az utols karakter utnra mutat
;
fk_hcon:ld	l,002h
	ld	h,a
	rrca
	rrca
	rrca
	rrca
hcon0:	and	00Fh
	add	a,030h
	cp	03Ah
	jr	c,hcon1
	add	a,007h
hcon1:	ld	(de),a
	inc	de
	ld	a,h
	dec	l
	jr	nz,hcon0
	ret

;
;	Angol kisbet nagybetv alaktsa
;	in:   A - ASCII karakterkd
;	out:  A - kisbetv alaktott karakter ha A < 128
;	     CY - vltozatlan marad
;
fk_tngy:bit	7,a
	ret	nz
	bit	6,a
	ret	z
	res	5,a
	ret

;
;	Kperny scroll-ozsa
;
fk_tvup:di
	ld	a,VID_PAGE_CFG		; A reg. = U0, U1, VID, CART
	out	(002h),a		; memrialapozs belltsa
	ld	hl,tvfst_ln*640+8000h
	ld	de,(tvfst_ln-1)*640+8000h
	ld	bc,(tvlst_ln-tvfst_ln)*640
	ldir
	ld	a,(0003Bh)		; A reg.= P_SAVE
	out	(002h),a		; memrialapozs visszalltsa
	ei
	ret
;
fk_tvdw:di
	ld	a,VID_PAGE_CFG		; A reg. = U0, U1, VID, CART
	out	(002h),a		; memrialapozs belltsa
	ld	hl,(tvlst_ln-1)*640-1+8000h
	ld	de,tvlst_ln*640-1+8000h
	ld	bc,(tvlst_ln-tvfst_ln)*640
	lddr
	ld	a,(0003Bh)		; A reg.= P_SAVE
	out	(002h),a		; memrialapozs visszalltsa
	ei
	ret

;
;	Kperny trlse
;
fk_tvcl:di
	ld	a,VID_PAGE_CFG		; A reg. = U0, U1, VID, CART
	out	(002h),a		; memrialapozs belltsa
	ld	hl,(tvfst_ln-1)*640+8000h
	ld	(hl),000h
	ld	e,l
	ld	d,h
	inc	de
	ld	bc,(((tvlst_ln+1)-tvfst_ln)*640)-1
	ldir
	ld	a,(0003Bh)		; A reg.= P_SAVE
	out	(002h),a		; memrialapozs visszalltsa
	ei
	ret


;
;-----------------------------------------------------
;	Sg kirsa
;-----------------------------------------------------
;

fk_sugo:ld	hl,sug_text
	call	fk_sug0			; elszr az alap parancsok, majd a fjlnz parancsainak kirsa
fk_sug0:ld	c,0			; GRAPHICS 2 belltsa, kperny trlse
	call	ed_vidmode
fk_sug1:call	ut_prntln		; egy sor kirsa a lezr nullig soremelssel
	ld	a,(hl)
	or	a
	jr	nz,fk_sug1		; ismtls a vgs lezr nullig
	inc	hl
	push	hl
	ld	c,008h			; vrakozs egy gomb lenyomsra (konzol input echo nlkl)
	call	0005h			; VT-DOS hvsa
	pop	hl
	ret
;
sug_text:
	.text	"Billenty\230zetparancsok\371\000"
	.text	"0\370\362ek felcser\221l\221se\000"
	.text	"1\370\364 az 1. \362re\000"		; "1 - vlts az 1. panelre"
	.text	"2\370\364 a  2. \362re\000"		; "2 - vlts az 2. panelre"
	.text	"3\370megtekint\000"			; "3 - megtekint"
	.text	"4\370\220\377\221s\000"		; "4 - tnevezs"
	.text	"5\370m\220sol\220s\000"		; "5 - msols"
	.text	"6\370\220\376\221s\000"		; "6 - thelyezs"
	.text	"7\370\226j\373\000"			; "7 - j knyvtr"
	.text	"SHIFT + DEL\t- t\224rl\221s\000"
	.text	"N/K/M/D\370rendez\221s: n\221v/kiterjeszt\221s/m\221ret/d\220tum\000"
	.text	"F\370szabad ter\227let ki\222r\220sa\000"
	.text	"G\370grafiku\363 \364a\000"		; "G - grafikus md vltsa"
	.text	"V\370\364 BASIC-be\000"		; "V - vlts BASIC-be"
	.text	"INS\370kijel\224l\221s\000"
	.text	"JOY\366\t- kurzor\366\000"		; "JOY fel/le - kurzor fel/le"
	.text	"JOY oldalra\t- \362\364 k\221t\362e\363ban\000"	; "JOY oldalra - panelvlts ktpaneles mdban"
	.text	"RETURN/JOY t\230z\t- kiv\220laszt\220s\000"
	.text	"\365\000"				; "ESC - kilps\r\n"
	.text	"Tov\220bb\367\000\000"			; "Tovbb gombnyomsra..."
;
	.text	"F\220jln\221z\225 parancsai\371\000"
	.text	"T\370sz\224vege\363\000"		; "T - szveges md"
	.text	"H\370hexadecim\220li\363\000"		; "H - hexadecimlis md"
	.text	"W\370sort\224r\221s be/ki\000"
	.text	"p/P\370oldal lapoz\220sa el\225re/h\220tra\000"
	.text	"JOY\366\t- egy sor\366\000"		; "JOY fel/le - egy sor fel/le"
	.text	"\365\000"				; "ESC - kilps\r\n"
	.text	"Visszat\221r\221s\367\000\000"		; "Visszatrs gombnyomsra..."
;

bvaltas	.text	"V\220lt\220s BASIC-be\000"		; "Vlts BASIC-be"
;
bnevez	.text	"\200\377ed\374\000"			; "tnevezed a kijellt fjlokat"
bmasol	.text	"\200tm\220solod\374\000"		; "tmsolod a kijellt fjlokat"
bhelyez	.text	"\200\376ed\374\000"			; "thelyezed a kijellt fjlokat"
bkonyvt	.text	"\206j\373\000"				; "j knyvtr"
btorol	.text	"\375\374\000"				; "Trld a kijellt fjlokat"
;
bfrdo	.text	"\371\371A f\220jl csak olvashat\223. \375\000"	; "\r\n\r\nA fjl csak olvashat. Trld"
bdne	.text	"\371\371A\373 nem \227res. \375\000"		; "\r\n\r\nA knyvtr nem res. Trld"
;
fnevez	.text	"\200\377\221s\372\371\000"		; "tnevezs  (ESC-Mgsem)\r\n"
fmasol	.text	"M\220sol\220s\371\000"			; "Msols\r\n"
fhelyez	.text	"\200\376\221s\371\000"			; "thelyezs\r\n"
fkonyvt	.text	"\206j\373\372\371\000"			; "j knyvtr  (ESC-Mgsem)\r\n"
ftorol	.text	"T\224rl\221s\371\000"			; "Trls\r\n"
;
fnevtxt	.text	"\371N\221v: \000"			; "\r\nNv: "
rnevtxt	.text	"\371Hib\220s n\221v!\000"		; hibazenet rvnytelen knyvtrnv/fjlnv megadshoz
;
fkftxt	.text	" (i-igen/b\220rmi m\220s-nem)\000"

;
;	Gyakran ismtld szvegrszletek
;
fk_txtspec
	.db	007h			; szveg hossza a hosszbjttal egytt
	.text	"tnevez"		; kd: \377
	.db	008h
	.text	"thelyez"		; kd: \376
	.db	007h
	.text	"T\224rl\224d"		; kd: \375
	.db	015h
	.text	" a kijel\224lt f\220jlokat"	; kd: \374
	.db	00Ah
	.text	" k\224nyvt\220r"	; kd: \373
	.db	00Fh
	.text	"  (ESC-M\221gsem)"	; kd: \372
	.db	003h
	.text	"\r\n"			; kd: \371
	.db	005h
	.text	"\t\t- "		; kd: \370
	.db	011h
	.text	" gombnyom\220sra..."	; kd: \367
	.db	008h
	.text	" fel/le"		; kd: \366
	.db	011h
	.text	"ESC\t\t- kil\221p\221s\r\n"	; kd: \365
	.db	007h
	.text	"v\220lt\220s"		; kd: \364
	.db	006h
	.text	"s m\223d"		; kd: \363
	.db	006h
	.text	"panel"			; kd: \362
	.db	0FFh			; a tblzatot zr 0FFh bjt (utols hasznlhat kd: \340)

;
;	Specilis karakterkdok helyettestse
;	in:   A - specilis kd (>223)
;	     DE - clcm a stringbufferben
;	out:  A - megrzdik
;	     BC - megrzdik
;	     DE - az utols karakter cme a stringbufferben
;	     HL - megrzdik
;
ut_pesc:push	bc
	push	hl
	push	de
	ld	hl,fk_txtspec		; HL az els szvegrszlet hosszbjtjra mutat
	ld	d,0FFh
	ld	b,000h
ut_pes0:ld	c,(hl)			; hosszbjt C-be
	cp	d
	jr	z,ut_pes1		; ugrs, ha megtallta a helyettest szveget
	dec	d			; kvetkez szveg indexe s cme
	add	hl,bc
	inc	c			; lezr 0FFh vizsglata
	jr	nz,ut_pes0		; ismtls a tblzat vgig
	pop	de
	pop	hl
	pop	bc
	ret
;
ut_pes1:dec	bc			; hosszbjt levonsa a szveg hosszbl
	inc	hl			; HL a msoland szvegre mutat
	pop	de			; DE a stringbufferre
	ldir				; szveg msolsa
	dec	de			; DE az utols karakterre mutat
	pop	hl
	pop	bc
	ret

;
;	Soremels a kpernyn
;
ut_lnf:	ld	c,00Dh			; '\r'
	call	ed_chout
	ld	c,00Ah			; '\n'
	call	ed_chout
	ret

;
;	Szveg kirsa soremelssel
;
ut_prntln:
	ld	bc,0000h		; aktulis pozciba r
ut_prntln0:
	ld	a,00Dh			; soremels ('\r')
	jr	ut_prn1

;
;	Szveg kirsa az aktulis vagy adott karakteres pozciba az IOMEM terletrl
;	in:  B  - X poz. ('ut_prn0'-nl s 'ut_prn4'-nl belpve)
;	     C  - Y poz. ('ut_prn0'-nl s 'ut_prn4'-nl belpve)
;	     DE - string utni cm strbuff-ban ('ut_prn4'-nl belpve)
;	     HL - 0-val lezrt string kezdete ('ut_prnt'-nl s 'ut_prn0'-nl belpve)
;	out: HL - a lezr nulla utni cm
;
ut_prnt:ld	bc,0000h		; aktulis pozciba r
ut_prn0:xor	a
ut_prn1:ld	de,strbuff		; szveg tmsolsa az U0 RAM-ba
	push	af
ut_prn2:ld	a,(hl)
	ld	(de),a
	cp	0E0h			; karakter >= 224?
	call	nc,ut_pesc		; ha igen, specilis kdok helyettestse
	inc	hl
	inc	de
	or	a
	jr	nz,ut_prn2
	dec	de
ut_prn3:pop	af
	or	a
	jr	z,ut_prn4
	ld	(de),a			; '\r'
	inc	de
	ld	a,00Ah			; '\n'
	ld	(de),a
	inc	de
ut_prn4:push	hl			; lezr nulla utni cm a verembe
	ex	de,hl
	ld	de,strbuff
	or	a
	sbc	hl,de			; stringhossz szmtsa
	jr	z,ut_prn5
	push	hl
	call	ed_cpos			; kurzor-pozicionls
	pop	bc
	ld	de,strbuff
	call	ed_bkout
ut_prn5:pop	hl			; lezr nulla utni cm HL-be
	ret

;
.end
